/**********************************************************************/
/* Copywrite Edscott Wilson Garcia 2005-2010
 * See attached GPL licence for further information.
 * 
 * ********************************************************************/

/*******************************************************************/

static void
child_constructor (
    widgets_t * widgets_p,
    char *path
) {
    char *command;
    if (strchr(path,':')) {
	command=g_strdup(strchr(path,':')+1);
    } else {
	gchar *esc_path = rfm_esc_string (path);
	command = g_strdup_printf ("rodent %s", esc_path);
	g_free (esc_path);
    }
    rfm_thread_run (widgets_p, command, FALSE);
    g_free (command);
}

static view_t *
create_deskview (
) {
    gint root_w,
      root_h;
    view_t *view_p = create_deskview_p ();

    view_p->serial = 1;
    /* initializations: */

    view_p->preferences = __SHOW_IMAGES;

    view_p->icon_size = 48;
    view_p->go_list = NULL;
    view_p->module_name = NULL;
    view_p->submodule_name = NULL;
    view_p->selection_list = NULL;
    view_p->penGC = NULL;
    view_p->cmap = NULL;
    view_p->dragstate = FALSE;
    view_p->widgets.popup = NULL;
    view_p->sortcolumn = GTK_TREE_SORTABLE_DEFAULT_SORT_COLUMN_ID;
    view_p->widgets.view_p = view_p;
    view_p->boxX = -1;
    view_p->boxY = -1;
    /* exported functions: */
    view_p->constructor = NULL;
    view_p->child_constructor = child_constructor;
    view_p->popup_constructor = child_constructor;

#if 0
    view_p->widgets.tubo_object = NULL;
    view_p->widgets.back_activate = gridview_back_activate;
    view_p->widgets.refresh = gridview_refresh;
    view_p->widgets.refresh_parent = gridview_refresh;
    view_p->widgets.open_with = gridview_open_with;
#endif

    view_p->widgets.window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
    gtk_widget_set_has_tooltip (view_p->widgets.window, TRUE);
    gtk_window_set_decorated ((GtkWindow *) view_p->widgets.window, FALSE);
    /* this doesn't do the trick with twm, so we'll just lower the window
       at the monitor step: */
    /*gdk_window_set_keep_below (((GtkWidget *)view_p->widgets.window)->window,TRUE); */
    view_p->type = DESKVIEW_TYPE;
    gtk_window_set_title (GTK_WINDOW (view_p->widgets.window), "Rodent-desk");
#if 0
    view_p->widgets.scrolled_window = (GtkScrolledWindow *) gtk_scrolled_window_new (NULL, NULL);
    gtk_scrolled_window_set_policy (view_p->widgets.scrolled_window, GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
    gtk_container_add (GTK_CONTAINER (view_p->widgets.window), GTK_WIDGET (view_p->widgets.scrolled_window));
    gtk_widget_show (GTK_WIDGET (view_p->widgets.scrolled_window));
#endif

    view_p->widgets.paper = gtk_drawing_area_new ();
    if(gtk_widget_get_double_buffered(view_p->widgets.paper))
        gtk_widget_set_double_buffered (view_p->widgets.paper, FALSE);
    gtk_widget_show (view_p->widgets.paper);

#if 0
    gtk_scrolled_window_add_with_viewport (view_p->widgets.scrolled_window, view_p->widgets.paper);
#else
    gtk_container_add (GTK_CONTAINER (view_p->widgets.window), GTK_WIDGET (view_p->widgets.paper));
#endif

    gdk_window_get_geometry (gdk_get_default_root_window (), NULL, NULL, &root_w, &root_h, NULL);
    gtk_window_set_default_size ((GtkWindow *) view_p->widgets.window, root_w, root_h);
    gtk_window_set_resizable ((GtkWindow *) view_p->widgets.window, FALSE);

    view_p->grid_extent = root_w * root_h / view_p->icon_size / view_p->icon_size;
    view_p->grid_flags = (char *) malloc (view_p->grid_extent * sizeof (char));
    memset (view_p->grid_flags, 0, view_p->grid_extent * sizeof (char));

    view_p->paperX = root_w + view_p->icon_size * 2;
    view_p->paperY = root_h + view_p->icon_size * 2;
    view_p->column_width = view_p->icon_size * 2;       // this is CELLWIDTH !!!

    TRACE ("paperX=%d\n", view_p->paperX);
    TRACE ("paperY=%d\n", view_p->paperY);
    gtk_widget_set_size_request (view_p->widgets.paper, view_p->paperX, view_p->paperY);

    do_atoms (view_p);

    gtk_widget_add_events (view_p->widgets.paper,
                           GDK_POINTER_MOTION_MASK |
                           GDK_BUTTON_MOTION_MASK |
                           GDK_BUTTON_PRESS_MASK |
                           GDK_BUTTON_RELEASE_MASK |
                           GDK_ENTER_NOTIFY_MASK | GDK_LEAVE_NOTIFY_MASK | GDK_SCROLL_MASK | GDK_EXPOSURE_MASK);

    g_signal_connect (G_OBJECT (view_p->widgets.window), "query-tooltip", G_CALLBACK (rodent_tip_function), NULL);
    g_signal_connect (G_OBJECT (view_p->widgets.paper), "scroll-event", G_CALLBACK (scroll_cb), NULL);
    g_signal_connect (G_OBJECT (view_p->widgets.paper), "configure-event", G_CALLBACK (on_configure), view_p);
    g_signal_connect (G_OBJECT (view_p->widgets.paper), "size-allocate", G_CALLBACK (on_size), view_p);

    g_signal_connect (G_OBJECT (view_p->widgets.paper), "expose-event", G_CALLBACK (rodent_expose), view_p);
    g_signal_connect (G_OBJECT (view_p->widgets.paper), "configure-event", G_CALLBACK (rodent_expose), view_p);

    g_signal_connect (G_OBJECT (view_p->widgets.paper), "button-press-event", G_CALLBACK (rodent_signal_on_button_press), view_p);
    g_signal_connect (G_OBJECT (view_p->widgets.paper), "button-release-event", G_CALLBACK (rodent_signal_on_button_release), view_p);
    g_signal_connect (G_OBJECT (view_p->widgets.paper), "enter-notify-event", G_CALLBACK (rodent_signal_on_enter), view_p);
    g_signal_connect (G_OBJECT (view_p->widgets.paper), "leave-notify-event", G_CALLBACK (rodent_signal_on_leave), view_p);
    g_signal_connect (G_OBJECT (view_p->widgets.paper), "motion-notify-event", G_CALLBACK (rodent_signal_on_motion), view_p);

    g_signal_connect (G_OBJECT (view_p->widgets.paper), "drag_data_received", G_CALLBACK (rodent_signal_drag_data), view_p);
    g_signal_connect (G_OBJECT (view_p->widgets.paper), "drag_data_get", G_CALLBACK (rodent_signal_drag_data_get), view_p);
    g_signal_connect (G_OBJECT (view_p->widgets.paper), "drag_motion", G_CALLBACK (rodent_signal_drag_motion), view_p);
    g_signal_connect (G_OBJECT (view_p->widgets.paper), "drag_end", G_CALLBACK (rodent_signal_drag_end), view_p);
    g_signal_connect (G_OBJECT (view_p->widgets.paper), "drag_begin", G_CALLBACK (rodent_signal_drag_begin), view_p);
    g_signal_connect (G_OBJECT (view_p->widgets.paper), "drag-leave", G_CALLBACK (rodent_signal_drag_leave), view_p);
    g_signal_connect (G_OBJECT (view_p->widgets.paper), "drag-data-delete", G_CALLBACK (rodent_signal_drag_delete), view_p);
//    g_signal_connect(G_OBJECT(view_p->widgets.paper), "drag-drop",
//          G_CALLBACK(rodent_signal_drag_drop), view_p);

    g_signal_connect (G_OBJECT (view_p->widgets.window), "destroy_event", G_CALLBACK (destroy_event), view_p);
    g_signal_connect (G_OBJECT (view_p->widgets.window), "delete_event", G_CALLBACK (destroy_event), view_p);

    rodent_create_target_list (view_p);
#if 0
    {
        TRACE ("hscrollbar=%d\n", view_p->widgets.scrolled_window->hscrollbar->allocation.height);
        TRACE ("vscrollbar=%d\n", view_p->widgets.scrolled_window->vscrollbar->allocation.width);
    }
#endif

    gtk_widget_show_all (view_p->widgets.window);
    rodent_clean_paper (view_p);
    screen_set_selection (view_p);
    /* get around fvwm margins: */
    gtk_window_move ((GtkWindow *) (view_p->widgets.window), 0, 0);

    rodent_add_view (view_p);
#if 0
    /* Make the root window send events to me */
    gdk_window_set_user_data (GDK_ROOT_PARENT (), view_p->widgets.paper);
    XSelectInput (GDK_DISPLAY (), GDK_ROOT_WINDOW (), PropertyChangeMask);
    g_signal_connect (G_OBJECT (view_p->widgets.paper), "property-notify-event", G_CALLBACK (handle_property_notify), view_p);
#endif
    TRACE ("create_deskview done----------------------------\n");
    DBG ("POP_SEM:  sem_init(&(view_p->population_sem),0,1)\n");

    return view_p;
}


/*********************************************************************/
