/* Copyright 2005-2010 Edscott Wilson Garca. 
 * Distributed with GPL licence.*/
#if 0
static void
graphics_expose_labels (
    view_t * view_p,
    int bottom_row,
    int bottom_column,
    int top_row,
    int top_column
) {
    DBG (">> graphics_expose_labels\n");
    int row,
      column;
    TRACE ("expose for grid elements %d,%d -> %d,%d", bottom_row, bottom_column, top_row, top_column);
    if(!view_p)
        return;
    for(column = bottom_column; column <= top_column; column++) {
        for(row = bottom_row; row <= top_row; row++) {

            int element = row * view_p->grid_columns + column;
            population_t *population_p;
            if(view_p->population_pp)
                population_p = view_p->population_pp[element];
            else
                population_p = NULL;
            TRACE ("exposing element %d,%d", row, column);
            rodent_select_pen (view_p, BACKGROUND_COLOR);
            /* if element is out of bounds, skip it */
            if(element >= view_p->max_elements)
                return;
            /* if element is repeated as first column of next row, skip it */
            if(element == (row + 1) * view_p->grid_columns)
                return;

            if(population_p) {
                int text_color = TEXT_COLOR;
                /* contents */

                if(population_p->en && population_p->en->path && !g_utf8_validate (population_p->en->path, -1, NULL))
                    text_color = INVALID_UTF8_TEXT_COLOR;
                TRACE ("drawing element %d,%d (0x%x)", row, column, (unsigned) population_p);

                if(population_p == view_p->label_p)
                    text_color = SATURATE_LABEL_COLOR;

                if(population_p->selected)
                    text_color = SELECT_TEXT_COLOR;
                else if(population_p == view_p->saturated_p)
                    text_color = SATURATE_TEXT_COLOR;
                rodent_select_pen (view_p, text_color);
                if(population_p->layout)
                    gdk_draw_layout (view_p->widgets.paper->window,
                                     view_p->penGC,
                                     column * CELLWIDTH + (CELLWIDTH -
                                                           population_p->logical_rect.width) / 2,
                                     row * CELLHEIGHT + TEXTSPACING + population_p->pixbufH, population_p->layout);
                if(population_p->layout2)
                    gdk_draw_layout (view_p->widgets.paper->window,
                                     view_p->penGC,
                                     column * CELLWIDTH + (CELLWIDTH -
                                                           population_p->logical_rect2.width) / 2,
                                     row * CELLHEIGHT + TEXTSPACING +
                                     population_p->pixbufH + population_p->logical_rect2.height, population_p->layout2);

            }
        }
    }
}
#endif

//#define DRAWABLE view_p->widgets.pixmap
#define DRAWABLE view_p->widgets.paper->window
static void
graphics_expose_item (
    view_t * view_p,
    int row,
    int column
) {
    TRACE ("EXPOSE>> graphics_expose_item\n");
    int element = row * view_p->grid_columns + column;
    population_t *population_p;
/* first, blank out space */
    TRACE ("exposing element %d,%d\n", row, column);
    rodent_select_pen (view_p, BACKGROUND_COLOR);
    gdk_draw_rectangle (DRAWABLE, view_p->penGC, TRUE, column * CELLWIDTH, row * CELLHEIGHT, CELLWIDTH, CELLHEIGHT);

    /* if element is out of bounds, skip it */
    if(element >= view_p->max_elements)
        return;
    /* if element is repeated as first column of next row, skip it */
    if(element == (row + 1) * view_p->grid_columns)
        return;

    if(view_p->population_pp)
        population_p = view_p->population_pp[element];
    else
        return;
    if(!population_p)
        return;

    TRACE ("drawing element %d,%d (0x%lx)\n", row, column, (unsigned long) population_p);
    if(population_p->pixbuf) {
        int x_spacing;

        x_spacing = (CELLWIDTH - population_p->pixbufW) / 2;
        if(x_spacing < 0)
            x_spacing = 0;
        GdkPixbuf *pixbuf;
        /*if (view_p->saturated_p != population_p && population_p->cut_pixbuf) 
           pixbuf=population_p->cut_pixbuf;
           else */
        pixbuf = population_p->pixbuf;
        gdk_draw_pixbuf (DRAWABLE,
                         view_p->penGC,
                         pixbuf,
                         0, 0,
                         column * CELLWIDTH + x_spacing,
                         row * CELLHEIGHT, population_p->pixbufW, population_p->pixbufH, GDK_RGB_DITHER_NONE, 0, 0);
        if(population_p->preview_done) {
            DBG ("MIME: %s is image type\n", population_p->en->mimetype);
            rodent_select_pen (view_p, SHADOW_COLOR);
            gdk_draw_rectangle (DRAWABLE,
                                view_p->penGC, TRUE,
                                column * CELLWIDTH + x_spacing + 2,
                                row * CELLHEIGHT + population_p->pixbufH, population_p->pixbufW + 1, 3);
            gdk_draw_rectangle (DRAWABLE,
                                view_p->penGC, TRUE,
                                column * CELLWIDTH + x_spacing +
                                population_p->pixbufW + 1, row * CELLHEIGHT + 1, 2, population_p->pixbufH + 2);
            // outline:
            if (view_p->saturated_p==population_p) {
                rodent_select_pen (view_p, 2);
            } else {
                rodent_select_pen (view_p, BACKGROUND_COLOR);
            }
            gdk_draw_rectangle (DRAWABLE,
                                view_p->penGC, FALSE,
                                column * CELLWIDTH + x_spacing + 1,
                                row * CELLHEIGHT + 1, population_p->pixbufW - 2, population_p->pixbufH - 2);
            rodent_select_pen (view_p, TEXT_COLOR);
            gdk_draw_rectangle (DRAWABLE,
                                view_p->penGC, FALSE,
                                column * CELLWIDTH + x_spacing, row * CELLHEIGHT, population_p->pixbufW, population_p->pixbufH);
        }
    }
    
    int text_color=rodent_text_color(population_p);
    rodent_select_pen (view_p, text_color);
    population_p->labelX = CELLWIDTH * population_p->column;
    population_p->labelY = CELLHEIGHT * population_p->row + view_p->icon_size;
    if(population_p->layout) {
        gdk_draw_layout (DRAWABLE,
                         view_p->penGC,
                         column * CELLWIDTH + (CELLWIDTH -
                                               population_p->logical_rect.width) / 2,
                         row * CELLHEIGHT + TEXTSPACING + population_p->pixbufH, population_p->layout);
    } else {
        DBG ("EXPOSE: population_p->layout is NULL!!!\n");
    }
    if(population_p->layout2) {
        gdk_draw_layout (DRAWABLE,
                         view_p->penGC,
                         column * CELLWIDTH + (CELLWIDTH -
                                               population_p->logical_rect2.width) / 2,
                         row * CELLHEIGHT + TEXTSPACING + population_p->pixbufH +
                         population_p->logical_rect2.height, population_p->layout2);
    }
    // this does a piece by piece expose
    /*  if (DRAWABLE == view_p->widgets.pixmap)
       {
       XCopyArea (GDK_DISPLAY (),
       GDK_PIXMAP_XID (view_p->widgets.pixmap),
       GDK_DRAWABLE_XID (view_p->widgets.paper->window),
       GDK_GC_XGC (view_p->penGC),
       column * CELLWIDTH, row * CELLHEIGHT,
       CELLWIDTH, CELLHEIGHT,
       column * CELLWIDTH, row * CELLHEIGHT);
       } */
}

/**
 * graphics_expose:
 *
 *    redraws a range of grid elements.
 *    
 *    To redraw by x,y coordinates, use
 *    gtk_widget_draw_queue_area(). This will in turn come
 *    back to this function with the correct grid range parameters.
 *    
 *    **/
//static gboolean    on_size_paper (GtkWidget *widget, GtkAllocation *allocation, gpointer user_data);
//static gboolean    on_size_window (GtkWidget *widget, GtkAllocation *allocation, gpointer user_data);
static void
graphics_expose (
    view_t * view_p,
    int bottom_row,
    int bottom_column,
    int top_row,
    int top_column
) {
    TRACE (">> graphics_expose\n");
    int row,
      column;
    TRACE ("expose for grid elements %d,%d -> %d,%d\n", bottom_row, bottom_column, top_row, top_column);
    if(!view_p)
        return;

//    on_size_paper (view_p->widgets.paper, NULL, (gpointer) view_p);
//    on_size_window (view_p->widgets.window, NULL, (gpointer) view_p);
    for(column = bottom_column; column <= top_column; column++) {
        for(row = bottom_row; row <= top_row; row++) {
            graphics_expose_item (view_p, row, column);
        }
    }
}

#if 0
static int
get_max_layout_width (
    view_t * view_p,
    xfdir_t * xfdir_p,
    int vport_width
) {
    DBG (">> get_max_layout_width\n");
    int i;
    int max_width = CELLHEIGHT;
    PangoLayout *layout = NULL;
    if(!xfdir_p || !xfdir_p->pathc) {
        return max_width;
    }
    for(i = 0; i < xfdir_p->pathc; i++) {
        PangoRectangle logical_rect;
        gchar *label = rfm_utf_string (xfdir_p->gl[i].pathv);
        layout = gtk_widget_create_pango_layout (view_p->widgets.paper, label);
        pango_layout_get_pixel_extents (layout, NULL, &(logical_rect));
        g_object_unref (layout);
        if((logical_rect.width / 2 + 2 * TEXTSPACING + 1) > max_width) {
            TRACE ("max width for %s\n", label);
            /* this is to fit at least 3 columns. anything less is not
             * an iconview but a listview */
            if(logical_rect.width / 2 + 2 * TEXTSPACING + 1 < vport_width / 3) {
                max_width = (logical_rect.width / 2 + 2 * TEXTSPACING + 1);
            } else {
                max_width = vport_width / 3;
            }
        }
        g_free (label);
    }
    return max_width;
}
#endif

