typedef struct environ_t {
    char *env_var;
    char *env_string;
    char *env_text;
} environ_t;

enum {
    /* check buttons: */
    /* general:: */
    RFM_DOUBLE_CLICK_NAVIGATION,        /* toggle */
    RFM_DRAG_DOES_COPY,         /* toggle */
    RFM_DISABLE_DIAGNOSTICS,    /* toggle */
    RFM_DISABLE_TIPS,           /* toggle */
    TERMINAL_CMD,               /* path selector */
    EDITOR_CMD,                 /* path selector */
    /* desktop:: */
    RFM_ENABLE_DESKTOP,         /* toggle */
    RFM_NAVIGATE_DESKTOP,       /* toggle */
    RFM_DESKTOP_DIR,            /* path selector */
    RFM_DESKTOP_IMAGE,          /* path selector */
    RFM_DESKTOP_COLOR,          /* color selector desktop */
    RFM_ICONVIEW_COLOR,         /* color selector iconview */
    RFM_TRANSPARENCY,           /* opacity selector, iconview */
    /* copy:: */
    RFM_CP_A,                   /* toggle */
    RFM_CP_RR,                  /* toggle */
    RFM_CP_L,                   /* toggle */
    RFM_CP_LL,                  /* toggle */
    RFM_CP_N,                   /* toggle */
    RFM_CP_PP,                  /* toggle */
    RFM_CP_P,                   /* toggle */
    RFM_CP_X,                   /* toggle */
    RFM_CP_HH,                  /* toggle */
#ifdef GNU_CP
    RFM_CP_D,                   /* toggle */
    RFM_CP_S,                   /* toggle */
    RFM_CP_B,                   /* toggle */
    RFM_CP_U,                   /* toggle */
#endif
    VERSION_CONTROL,            /* drop down selection */
// ln
    RFM_LN_S,                   /* toggle */
//  cp/ln/mv
    RFM_CP_VERBOSE,             /* toggle */
// remove:
    RFM_RM_VERBOSE,             /* toggle */
#ifdef GNU_RM
    RFM_RM_ONE_FILE_SYSTEM,     /* toggle */
#endif
//    RFM_RM_INTERACTIVE,                       /* toggle */
// shred:
#ifdef GNU_SHRED
    RFM_SHRED_VERBOSE,             /* toggle */
    RFM_SHRED_REMOVE,           /* toggle */
    RFM_SHRED_ZERO,             /* toggle */
    RFM_SHRED_ITERATIONS,       /* spinbutton */
#endif
    SMB_USER,                   /* input text */
    SUDO_ASKPASS,
    RFM_PASTEBOARD_SERIAL,
    /* what's this for? */
    PWD,                        //XXX
    RFM_OPTIONS
};
/* increment version number for MCS_FILE_NAME on configuration changes
 * (i.e. adding or removing configuration environment variables) */
// MCS_FILE_NAME depends on BUILD, so that BUILD id should be incremented
//      with each modification to rfm environment variables, otherwise,
//      increment value after BUILD:
# define MCS_FILE_NAME "rfm-"BUILD"3"
# define MCS_SHM_PLUGIN_FILE g_get_user_config_dir(),"rfm",MCS_FILE_NAME

# ifdef RFM_PRIMARY_C
rfm_global_t *rfm_global_p = NULL;
/* the size of env_string must coincide with that of env_vars! 
*/
environ_t environ_v[RFM_OPTIONS + 1] = {        
    // +1 because zero does not count in enum...
    /* general:: */
    { "RFM_DOUBLE_CLICK_NAVIGATION", NULL, N_("Activate items with a _double click")}, 
    { "RFM_DRAG_DOES_COPY", NULL, N_("Drag and drop does copy, not move")}, 
    { "RFM_DISABLE_DIAGNOSTICS", NULL, N_ ("Disable diagnostics output")},
    { "RFM_DISABLE_TIPS", NULL, N_("Disable preview popups")}, 
    { "TERMINAL_CMD", "xterm", N_("Terminal command")}, 
    { "EDITOR_CMD", "gvim", N_("Editor command")},
    /* desktop:: */
    { "RFM_ENABLE_DESKTOP", "yes", N_("Enable icons on root window")}, 
    { "RFM_NAVIGATE_DESKTOP", NULL, N_("Navigational desktop")}, 
    { "RFM_DESKTOP_DIR", NULL, N_("Path to the desktop directory")},
    { "RFM_DESKTOP_IMAGE", NULL, N_("Background image")}, 
    { "RFM_DESKTOP_COLOR", "#283F3F", N_("Background color")}, 
    { "RFM_ICONVIEW_COLOR", "#F3FAFF", N_("Background color")},
    { "RFM_TRANSPARENCY", NULL, N_("Background transparency:")},
    // cp
    { "RFM_CP_A", NULL, N_("No dereference, recurse directories and preserve all")}, 
    { "RFM_CP_RR", "yes", N_("Recurse directories")}, 
    { "RFM_CP_L", NULL, N_("Link files instead of copying")},
    { "RFM_CP_LL", NULL, N_("Always follow symbolic links in SOURCE")}, 
    { "RFM_CP_N", NULL, N_("Do not overwrite an existing file")}, 
    { "RFM_CP_PP", "yes", N_("Never follow symbolic links in SOURCE")},
    { "RFM_CP_P", "yes", N_("Preserve mode, ownership, and timestamps")}, 
    { "RFM_CP_X", NULL, N_("Stay on single file system")}, 
    { "RFM_CP_HH", NULL, N_("Follow command-line symbolic links")},
#ifdef GNU_CP
    { "RFM_CP_D", "yes", N_("No dereference, and preserve links")}, 
    { "RFM_CP_S", NULL, N_("Make symbolic links instead of copying")}, 
    // cp/mv
    { "RFM_CP_B", "yes", N_("Make a backup of each existing destination file")},
    { "RFM_CP_U", NULL, N_("Copy  only  when the SOURCE is newer than the \ndestination or when the destination is missing")},
#endif
    { "VERSION_CONTROL", "existing", N_("Version control method")},
    // ln
    { "RFM_LN_S", "yes", N_("Make symbolic links instead of hard links (with DnD)")},
    // cp/mv/ln
    { "RFM_CP_VERBOSE", NULL, N_("Verbose")}, 
// remove:
    { "RFM_RM_VERBOSE", NULL, N_("Verbose")},
//    {"RFM_RM_INTERACTIVE","yes",N_("Prompt before removal")},
#ifdef GNU_RM
    { "RFM_RM_ONE_FILE_SYSTEM", "yes", N_("Exclude other filesystems")},
#endif
// shred:
#ifdef GNU_SHRED
    { "RFM_SHRED_VERBOSE", NULL, N_("Verbose")},
    // Truncate and remove file after overwriting
    // Overwrite File?
    // "Overwrite File"
    // "Overwrite with:"
    { "RFM_SHRED_REMOVE", NULL, N_("Delete files")}, 
    // Add a final overwrite with zeros to hide shredding
    { "RFM_SHRED_ZERO", "yes", N_("Overwrite with:")" 0"},
    // 
    { "RFM_SHRED_ITERATIONS", NULL, N_("shred: Overwrite N times instead of the default (3)")},
#endif
    {"SMB_USER", NULL, N_("Samba default remote user")}, 
    {"SUDO_ASKPASS", "rodent-getpass", "Sudo ask password program"}, 
    {"RFM_PASTEBOARD_SERIAL", "0", "Pasteboard serial control"},
    /* what's this for? */
    { "PWD", NULL, "fixme"},     //XXX
    { NULL, NULL, NULL}
};

# else
extern rfm_global_t *rfm_global_p;
extern environ_t environ_v[];
# endif

