#ifndef RFM_PRIMARY_H
# define RFM_PRIMARY_H

void
  rfm_expose_rect (GdkWindow * window, GdkRectangle * rect);

#include "primary-environment.i"

# include <X11/Xmd.h>
# include <X11/SM/SMlib.h>

void
  smc_connect (gint argc, gchar ** argv, CARD8 style_hint);

//

gboolean
  rfm_write_ok (struct stat *st);

GtkWidget *
  rfm_get_widget_by_name (GtkWidget * parent, const gchar * name);

void
  rfm_set_widget_by_name (GtkWidget * parent, const gchar * name, 
	  GtkWidget * widget);

void
  rfm_lock_fd_read (int fd);

void
  rfm_lock_fd_write (int fd);

void
  rfm_unlock_fd (int fd);

int
  rfm_mkdir (const gchar * dir);

void
  rfm_rm_local_cache (view_t * view_p);

void
  rfm_save_to_go_history (char *p);

void
  rfm_threadwait (void
    );

void
  rfm_init_env (void);

void
  rfm_setenv (const char *name, char *value, gboolean verbose);

gchar *
  rfm_esc_string (const gchar * string);

const gchar *
  rfm_chop_excess (gchar * b);

gchar *
  rfm_time_to_string (time_t when);

char *
  rfm_mode_string (mode_t mode);

gchar *
  rfm_utf_string (const gchar * t);

gchar *
  rfm_sizetag (off_t tama, gint count);

gchar *
  rfm_host_name (Window xid);

gboolean 
  rfm_population_write_lock (view_t * view_p);

void
  rfm_population_write_unlock (view_t * view_p);

gboolean 
  rfm_population_read_lock (view_t * view_p);

gboolean 
  rfm_population_try_read_lock (view_t * view_p);

void
  rfm_population_read_unlock (view_t * view_p);

int
  rfm_valid_pasteboard (view_t * view_p);

int
  rfm_in_pasteboard (view_t * view_p, record_entry_t * en);

gboolean 
  rfm_update_pasteboard (view_t * view_p);

void
  rfm_soft_reload (view_t * view_p);

#endif
