#ifndef RODENT_GRIDVIEW_H
#define RODENT_GRIDVIEW_H
typedef struct view_geometry_t {
    gdouble scrollX;
    int x;
    int y;
    int w;
    int h;
} view_geometry_t;

typedef struct view_preferences_t {
    int preferences;
    int sortcolumn;
} view_preferences_t;

view_t *
rodent_get_current_view ( GtkWidget * window);

int 
rodent_text_color(population_t *population_p);

view_geometry_t *
rodent_get_view_geometry_p (view_t * view_p);

void
rodent_save_view_preferences (view_t * view_p);

view_preferences_t *
rodent_get_view_preferences (const gchar * path);

void
  rodent_save_root_view_geometry_p (view_t * view_p);

void
  rodent_save_local_view_geometry_p (view_t * view_p);

void
  rodent_set_scroll (view_t * view_p, double scroll_position);

void
  rodent_set_scroll_position (view_t * view_p);

void
  rodent_restore_view_size (view_t * view_p);

void
  rodent_init_grid (view_t * view_p, int pathc);

gboolean 
rodent_on_size (view_t * view_p, int width, int height);

#endif
